#include <stdio.h>
#include <stdbool.h>
#include "punto.h"
#include "rettangolo.h"


/*
 * Riceve due punti a, b e restituisce il rettangolo con i lati paralleli 
 * agli assi cartesiani che ha il segmento ab come diagonale. 
 */
struct rettangolo crea_rettangolo(struct punto a, struct punto b) {
	struct rettangolo r;

	if (a.ascissa < b.ascissa) {
		r.max.ascissa = b.ascissa;
		r.min.ascissa = a.ascissa;
	} else {
		r.max.ascissa = a.ascissa;
		r.min.ascissa = b.ascissa;
	}
	if (a.ordinata < b.ordinata) {
		r.max.ordinata = b.ordinata;
		r.min.ordinata = a.ordinata;
	} else { 
		r.max.ordinata = a.ordinata;
		r.min.ordinata = b.ordinata;
	}

	return r;
}

/*
 * Verifica se il rettangolo this include il rettangolo that. 
 */
bool include(struct rettangolo this, struct rettangolo that) {
	if (this.max.ascissa >= that.max.ascissa &&
		this.max.ordinata >= that.max.ordinata &&
		this.min.ascissa <= that.min.ascissa &&
		this.min.ordinata <= that.min.ordinata)
		return true;
	return false;
}


/*
 * Verifica se due rettangoli sono uguali. 
 */
bool equals_rettangoli(struct rettangolo this, struct rettangolo that) {
	if (equals_punti(this.max, that.max) && equals_punti(this.min, that.min))
		return true;
	return false;
}
