#ifndef RETTANGOLO_H
#define RETTANGOLO_H

#include <stdbool.h>
#include "punto.h"


/* 
 * Rettangolo con i lati paralleli agli assi cartesiani.
 * Utilizza una struttura normalizzata.
 * Rappresenta ogni rettangolo con due vertici:
 * uno con ascissa e ordinata minime
 * uno con ascissa e ordinata massime
 */
struct rettangolo {
	struct punto min; // vertice a sinistra in basso (ascissa e ordinata minime)
 	struct punto max; // vertice a destra in alto (ascissa e ordinata massime)
};

/* Restituisce il rettangolo che i due punti come vertici opposti. */
struct rettangolo crea_rettangolo(struct punto, struct punto);

/* Verifica se il primo rettangolo include il secondo. */
bool include(struct rettangolo, struct rettangolo);

/* Verifica se i due rettangoli sono uguali. */
bool equals_rettangoli(struct rettangolo, struct rettangolo); 

#endif
